#include <stdio.h>
#include <stdlib.h>
#include <libvirt/libvirt.h>
int main(int argc, char *argv[]){
	virConnectPtr conn;
	virDomainPtr dom;
	virDomainInfoPtr info;

	const char *filename = "/var/lib/libvirt/save/test-guest.img";
	conn = virConnectOpen("xen:///");
	
	if (conn == NULL) {
		fprintf(stderr, "Failed to open connection to xen:///\n");
		return -1;
	}

	// test-guest  ӽ ڵ  ȹ
	dom = virDomainLookupByName(conn, "test-guest");
	
	if (!dom) {
		fprintf(stderr, "Cannot find guest to be saved");
		return -1;
	}
	
	//  ӽ  Ȯ
	if (virDomainGetInfo(dom, &info) < 0) {
		fprintf(stderr, "Cannot check guest state");
		return -1;
	}

	//  ӽ °  ߴ ° ƴ ȮѴ.
	//  ӽ ߴ ̸   .
	
	if (info.state == VIR_DOMAIN_SHUTOFF) {
		fprintf(stderr, "Not saving guest that isn't running");
		return -1;
	}
	
	//  ӽ 
	if (virDomainSave(dom, filename) < 0) {
		fprintf(stderr, "Unable to save guest to %s", filename);
		return -1;
	}
	
	fprintf(stderr, "Guest state saved to %s", filename);
	
	virConnectClose(conn);
	return 0;
}